/*
 *		P M O N . H
 *
 *  Contains all includes and global defines/data needed by "pmon"
 */
#include <stdio.h>
#include <sys/types.h>
#include <sys/param.h>	/* Needed by user.h */
#include <sys/dir.h>	/* Needed by namei which is included with user.h! */
#include <sys/user.h>
#include <sys/proc.h>
#include <nlist.h>
#ifdef BSD42
#include <vax/pte.h>
#else
#include <machine/pte.h>
#endif
#if	defined(ultrix) && defined(mips)
#include <sys/fixpoint.h>
#endif	/* mips ultrix */

/*
 * The main namelist entries.  This order MUST correspond to the
 *  definition of namelist in main.
 */
#define	LOADAV		0
#define	X_PROC		1
#define	X_NPROC		2
#define	X_USRPTMAP	3
#define	X_USRPT		4

/*
 *  The namelist array.  Uses to get the kernal variables needed
 *  by all the PMON routines.  The order of this list MUST correspond
 *  to the order of the definitions in mon.h
 */
extern struct nlist namelist[];

/*
 * Screen Positions - these would be in display.c if all
 *  output occured there.
 */
#define	LEFT	0
#define	TOP	2	/* Command, user, etc */
#define	TIMERY	2
#define	TIMERX	45
#define	MEMY	2
#define	MEMX	45
#define	IDY	8
#define	SCHY	7	/* Priorities, et al. */
#define	SCHX	40
#define	STATY	7
#define	SIGY	9
#define	FILEY	13

#define	FDISPLAY	9	/* Number of file lines on screen */
extern	int	fdbase;		/* num fd's to skip on display */
int nproc;
struct proc *procp;

/*extern struct nlist namelist[];*/
int kmem, mem, swap;
int intv;			/* interval time */
#ifdef SUN
long loadavg[3];
#else SUN
double loadavg[4];
#endif SUN
#ifdef	_FIXPT_
fix	fixloadavg[3];
#endif	_FIXPT_

union {
	struct user user;
	char	upages[UPAGES][NBPG];
} user;

#define	u	user.user

struct	pte	*Usrptmap, *usrpt;
struct	proc	pr;

char *openfiles();

/*
 * Descriptor table entry.
 * One for each kernel object.
 */
struct	file {
	int	f_flag;		/* see below */
	short	f_type;		/* descriptor type */
	short	f_count;	/* reference count */
	short	f_msgcount;	/* references from message queue */
	struct	fileops {
		int	(*fo_rw)();
		int	(*fo_ioctl)();
		int	(*fo_select)();
		int	(*fo_close)();
	} *f_ops;
	caddr_t	f_data;		/* inode */
	off_t	f_offset;
};
